var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
var LineChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) || false,
                orient: ((_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.legend) === null || _d === void 0 ? void 0 : _d.orient) || 'horizontal',
                align: ((_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.legend) === null || _f === void 0 ? void 0 : _f.align) || 'auto',
            },
            tooltip: {
                show: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.tooltip) === null || _h === void 0 ? void 0 : _h.show) || false,
                trigger: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.tooltip) === null || _k === void 0 ? void 0 : _k.trigger) || 'item',
                backgroundColor: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.tooltip) === null || _m === void 0 ? void 0 : _m.backgroundColor) || '#000',
                borderRadius: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_s = (_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.textStyle) === null || _s === void 0 ? void 0 : _s.fontSize) || 'normal',
                    color: ((_v = (_u = (_t = props.setup.chart) === null || _t === void 0 ? void 0 : _t.tooltip) === null || _u === void 0 ? void 0 : _u.textStyle) === null || _v === void 0 ? void 0 : _v.color) || '#fff',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.seri) === null || _x === void 0 ? void 0 : _x.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c, _d;
                    return ((_b = (_a = props.chartData) === null || _a === void 0 ? void 0 : _a.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _b === void 0 ? void 0 : _b[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.y_axis) === null || _d === void 0 ? void 0 : _d.field]) || 0;
                }), true); }), true),
            },
            xAxis: {
                type: 'category',
                min: ((_z = (_y = props.setup.chart) === null || _y === void 0 ? void 0 : _y.x_axis) === null || _z === void 0 ? void 0 : _z.min) || undefined,
                max: ((_1 = (_0 = props.setup.chart) === null || _0 === void 0 ? void 0 : _0.x_axis) === null || _1 === void 0 ? void 0 : _1.max) || undefined,
                axisLabel: {
                    rotate: ((_4 = (_3 = (_2 = props.setup.chart) === null || _2 === void 0 ? void 0 : _2.x_axis) === null || _3 === void 0 ? void 0 : _3.axisLabel) === null || _4 === void 0 ? void 0 : _4.rotate) || 0,
                },
                splitLine: {
                    lineStyle: {
                        color: ((_8 = (_7 = (_6 = (_5 = props.setup.chart) === null || _5 === void 0 ? void 0 : _5.x_axis) === null || _6 === void 0 ? void 0 : _6.splitLine) === null || _7 === void 0 ? void 0 : _7.lineStyle) === null || _8 === void 0 ? void 0 : _8.color) || '#e9e9eb',
                        type: ((_12 = (_11 = (_10 = (_9 = props.setup.chart) === null || _9 === void 0 ? void 0 : _9.x_axis) === null || _10 === void 0 ? void 0 : _10.splitLine) === null || _11 === void 0 ? void 0 : _11.lineStyle) === null || _12 === void 0 ? void 0 : _12.type) || 'solid',
                        width: ((_16 = (_15 = (_14 = (_13 = props.setup.chart) === null || _13 === void 0 ? void 0 : _13.x_axis) === null || _14 === void 0 ? void 0 : _14.splitLine) === null || _15 === void 0 ? void 0 : _15.lineStyle) === null || _16 === void 0 ? void 0 : _16.width) || 1,
                    },
                },
            },
            yAxis: {
                type: 'value',
                min: ((_18 = (_17 = props.setup.chart) === null || _17 === void 0 ? void 0 : _17.y_axis) === null || _18 === void 0 ? void 0 : _18.min) || undefined,
                max: ((_20 = (_19 = props.setup.chart) === null || _19 === void 0 ? void 0 : _19.y_axis) === null || _20 === void 0 ? void 0 : _20.max) || undefined,
                axisLabel: {
                    rotate: ((_23 = (_22 = (_21 = props.setup.chart) === null || _21 === void 0 ? void 0 : _21.y_axis) === null || _22 === void 0 ? void 0 : _22.axisLabel) === null || _23 === void 0 ? void 0 : _23.rotate) || 0,
                },
                splitLine: {
                    lineStyle: {
                        color: ((_27 = (_26 = (_25 = (_24 = props.setup.chart) === null || _24 === void 0 ? void 0 : _24.y_axis) === null || _25 === void 0 ? void 0 : _25.splitLine) === null || _26 === void 0 ? void 0 : _26.lineStyle) === null || _27 === void 0 ? void 0 : _27.color) || '#e9e9eb',
                        type: ((_31 = (_30 = (_29 = (_28 = props.setup.chart) === null || _28 === void 0 ? void 0 : _28.y_axis) === null || _29 === void 0 ? void 0 : _29.splitLine) === null || _30 === void 0 ? void 0 : _30.lineStyle) === null || _31 === void 0 ? void 0 : _31.type) || 'solid',
                        width: ((_35 = (_34 = (_33 = (_32 = props.setup.chart) === null || _32 === void 0 ? void 0 : _32.y_axis) === null || _33 === void 0 ? void 0 : _33.splitLine) === null || _34 === void 0 ? void 0 : _34.lineStyle) === null || _35 === void 0 ? void 0 : _35.width) || 1,
                    },
                },
            },
            series: props.setup.type === 'step-line-chart'
                ? Array.from(serials).map(function () {
                    return { type: 'line', step: 'middle' };
                })
                : Array.from(serials).map(function (value, index) {
                    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
                    return {
                        type: 'line',
                        symbolSize: 0,
                        lineStyle: {
                            color: (_e = (_d = (_c = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[index]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.line_color) !== null && _e !== void 0 ? _e : '#000',
                        },
                        smooth: (_k = (_j = (_h = (_g = (_f = props.setup.chart) === null || _f === void 0 ? void 0 : _f.item_styles) === null || _g === void 0 ? void 0 : _g[index]) === null || _h === void 0 ? void 0 : _h.style) === null || _j === void 0 ? void 0 : _j.smooth) !== null && _k !== void 0 ? _k : false,
                    };
                }),
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption() });
};
export default LineChart;
