var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var handleInputChange = function (code, value, dataType) {
        var parsedValue = value;
        switch (dataType) {
            case 'integer':
                parsedValue = parseInt(value);
                break;
            case 'double':
                parsedValue = parseFloat(value);
                break;
            case 'boolean':
                parsedValue = Boolean(value);
                break;
            case 'datetime':
                parsedValue = new Date(value).toISOString();
                break;
            default:
                parsedValue = value;
        }
        setFilterValues(function (param) {
            var _a;
            return (__assign(__assign({}, param), (_a = {}, _a[code] = parsedValue, _a)));
        });
    };
    var renderInput = function (parameter) {
        var _a, _b;
        var value = parameter.code ? ((_b = (_a = filterValues[parameter.code]) !== null && _a !== void 0 ? _a : parameter.default) !== null && _b !== void 0 ? _b : '') : '';
        switch (parameter.input_type) {
            case 'number':
                return (_jsx("input", { type: "number", value: value, onChange: function (e) { return handleInputChange(parameter.code, e.target.value, parameter.data_type); } }));
            case 'checkbox':
                return (_jsx("input", { type: "checkbox", checked: !!value, onChange: function (e) {
                        return handleInputChange(parameter.code, e.target.checked, parameter.data_type);
                    } }));
            case 'date':
                return (_jsx("input", { type: "date", value: value, onChange: function (e) { return handleInputChange(parameter.code, e.target.value, parameter.data_type); } }));
            case 'datetime':
                return (_jsx("input", { type: "datetime-local", value: value, onChange: function (e) { return handleInputChange(parameter.code, e.target.value, parameter.data_type); } }));
            case 'dropdown':
                return (_jsx("select", { value: value, onChange: function (e) { return handleInputChange(parameter.code, e.target.value, parameter.data_type); }, children: _jsx("option", { value: "", children: "Select..." }) }));
            default:
                return (_jsx("input", { type: "text", value: value, onChange: function (e) { return handleInputChange(parameter.code, e.target.value, parameter.data_type); } }));
        }
    };
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsx("h3", { children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("div", { className: "filter-content", children: (parameters === null || parameters === void 0 ? void 0 : parameters.length) > 0 &&
                        parameters.map(function (parameter) { return (_jsxs("div", { className: "filter-item", children: [_jsx("label", { children: parameter.label || parameter.code }), renderInput(parameter)] }, parameter.code)); }) }), _jsxs("div", { className: "filter-actions", children: [_jsx("button", { className: "filter-actions__accept", onClick: function () { return onApply(filterValues); }, children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("button", { className: "filter-actions__cancel", onClick: onClose, children: "H\u1EE7y" })] })] }) }));
};
export default Filter;
