var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import ChartContainer from './ChartContainer.js';
var SDashboard = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), dashboardItems = _b[0], setDashboardItems = _b[1];
    var getItemsAsync = function () { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetItemsAsync({
                            dashboardCode: props.dashboardCode,
                        })];
                case 1:
                    result = _b.sent();
                    if ((result === null || result === void 0 ? void 0 : result.length) === 0) {
                        setStatus('empty');
                        setDashboardItems([]);
                    }
                    else {
                        setStatus('loaded');
                        setDashboardItems(result);
                    }
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setDashboardItems([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getItemsAsync();
    }, []);
    if (status === 'empty') {
        if (props.emptySDashboard)
            return props.emptySDashboard;
        return (_jsx("div", { className: "s-dashboard s-dashboard-empty", children: _jsx("h1", { children: "No data for dashboard" }) }));
    }
    if (status === 'loading') {
        if (props.loadingSDashboard)
            return props.loadingSDashboard;
        return (_jsx("div", { className: "s-dashboard s-dashboard-loading", children: _jsx("h1", { children: "Loading dashboard..." }) }));
    }
    if (status === 'error') {
        if (props.errorSDashboard)
            return props.errorSDashboard;
        return (_jsx("div", { className: "s-dashboard s-dashboard-error", children: _jsx("h1", { children: "Error dashboard" }) }));
    }
    return (_jsxs("div", { className: "s-dashboard s-dashboard-loaded", style: {
            display: 'grid',
            gridTemplateColumns: "repeat(".concat(props.grid_column || 2, ", 1fr)"),
            backgroundColor: props.background || 'transparent',
            gap: (props.gap || 16) + 'px',
        }, children: [props.title && _jsx("h1", { className: "s-dashboard-title", children: props.title }), dashboardItems.map(function (item, index) { return (_jsx(ChartContainer, { setup: item.setup, index: index, configuration: props.configuration }, index)); })] }));
};
export default SDashboard;
